
set heading off
set feedback off
set echo off
set termout off
set pagesize 0
set timing off
set show off
set serveroutput on

spool "graph.spool.sql"

declare 
  cursor cur is
    select 
      p.OWNER, 
      p.OBJECT_NAME, 
      p.PROCEDURE_NAME
    from all_procedures p 
    where p.OBJECT_TYPE = 'PACKAGE'
      and p.OWNER in ( 'JD' )
      and p.OBJECT_NAME not like '%\_TEST' escape '\'
      and p.OBJECT_NAME in( 'CALLGRAPH_PAC' ) 
      and p.PROCEDURE_NAME not in ( 'LOG' )
    order by p.OWNER, p.OBJECT_NAME, p.PROCEDURE_NAME;

  filename  varchar2(1000);

begin
  dbms_output.enable(null);

  for rec in cur loop
    
    filename := 'graph.' || lower(rec.owner) || '.'  || lower(rec.object_name) || '.' || lower(rec.procedure_name);
    
    dbms_output.put_line( 'set termout on' );
    dbms_output.put_line( 'prompt bearbeite ' || filename );    
    dbms_output.put_line( 'set heading off feedback off echo off termout off timing off serveroutput on pagesize 0' );

    dbms_output.put_line( 'spool ' || filename );
    dbms_output.put_line( 'exec callgraph_pac.get_graph( ''' || rec.owner || ''', ''' 
                                                             || rec.object_name || ''', ''' 
                                                             || rec.procedure_name || ''' );' );
    dbms_output.put_line( 'spool off;' );
    
    dbms_output.put_line( 'host dot -O -T png ' || filename );

    dbms_output.put_line( 'host rm ' || filename );    
    -- oder auf MS-Kommandozeile
--    dbms_output.put_line( 'host del ' || filename );
    
    dbms_output.new_line;
  end loop; 
end;
/    
spool off;

@graph.spool.sql

