create or replace package callgraph_demo authid definer is
/*******************************************************************************
  Demo-Package fr Callgraph-Erzeugung


  %author j.demuth (jd)

  %change 2021-03-08  1.0 (jd)  erstellt
*******************************************************************************/

procedure demo;


end callgraph_demo;
/
create or replace package body callgraph_demo is

procedure call_1;
procedure call_2;
procedure overload( p_zahl in number );
procedure overload( p_text in varchar2 );


-- Prozedur, die nicht im Callgraph auftauchen soll
procedure log_it( p_text in varchar2 )
is
begin
  dbms_output.put_line( 'Log: ' || p_text );
end;  


-- Funktion die als Parameter in callgraph_demo_wrapped verwendet wird.
function get_name
  return varchar2
is
begin
  log_it( 'get_name');  
  return 'Max Mustermann';
end get_name;    


procedure call_1
is 
begin 
  log_it( 'call_1'); 
     
  call_2; 
  
  if false then 
    call_1; 
  end if;
end call_1;


procedure call_2
is begin 
  log_it( 'call_2'); 
  overload( 0 ); 
  
  if false then
    call_1; 
  end if;
end call_2;  


procedure overload( p_zahl in number )
is begin   
  log_it( 'overload( number )'); 
end;
  

procedure overload( p_text in varchar2 )
is
  name_ varchar2(100);
  
  procedure over_intern
  is
    my_name varchar2(30);
  begin
    my_name := get_name;
  end;
begin   
  log_it( 'overload( varchar2 )'); 
  name_ := get_name;
  over_intern;
end;



-- 
procedure demo
is
  hello  varchar2(100);
begin
  log_it( 'demo: start');

  hello := callgraph_demo_wrapped.say_hello( get_name );
  hello := callgraph_demo_wrapped.say_hello( 'Hilde' );
  callgraph_demo_proc;
  callgraph_syn;
  call_1;
  call_2;
  overload( 'hy' );

  log_it( 'demo: ende');  
end demo;


begin
  dbms_output.enable(1000000);
end callgraph_demo;
/
